



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>用Spring Boot颠覆Java应用开发</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">用Spring Boot颠覆Java应用开发</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 11:04:08 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><img referrerpolicy="no-referrer"src="http://img2.tuicool.com/7jIZJnb.png!web"></p>
<h2><strong>Java开发概述：</strong></h2>
<p>使用Java做Web应用开发已经有近20年的历史了，从最初的Servlet1.0一步步演化到现在如此多的框架，库以及整个生态系统。经过这么长时间的发展，Java作为一个成熟的语言，也演化出了非常成熟的生态系统，这也是许多公司采用Java作为主流的语言进行服务器端开发的原因，也是为什么Java一直保持着非常活跃的用户群。然而这个生态系统纷繁复杂，一个非常简单的Java Web应用程序都有可能应用到以下技术：</p>
<p><img referrerpolicy="no-referrer"src="http://img2.tuicool.com/yU3EZv.png!web"></p>
<p>Java开发分为两个阵营，一个是由Oracle 为代表的Java EE阵营，这是Web开发的官方参考标准。其中核心技术主要有Servlet, EJB, JMS, JSF, JDBC/JPA, JAXB, JAX-WS等。另一个阵营则是由开源社区以及Pivotal代表的Spring阵营，其中核心技术主要有 Spring Framework, Spring MVC, Spring Data, Spring Security等等。</p>
<p>Spring从最开始作为依赖注入的Bean container，逐渐发展为Java应用开发的主流框架。Java EE因为其臃肿，复杂，难以使用的结构，被很多Java程序员抛弃。从Java EE6开始才引入了CDI (Context Dependency Injection)，而且Java EE 的设计思想非常学术化, Gavin King等人脱离了工业界的需求，使得Java EE开发非常复杂。JSF甚至为Java之父James Gosling诟病。相反在Spring社区，越来越多现代化的应用开发方法被融入进来，形成不同的Spring项目。</p>
<h2><strong>什么是Spring Boot?</strong></h2>
<p>Spring Boot便是一个社区反馈推动的项目. Spring Boot可以说是至少近5年来Spring乃至整个Java社区最有影响力的项目之一。Spring Boot主要包含以下特性：</p>
<ul><li><p>直接嵌入Tomcat, Jetty或者Undertow作为Servlet container。从此之后再也不用将应用程序打包成war然后上传到application server里面了。</p></li>
<li><p>提供了starter POM, 能够非常方便的进行包管理, 很大程度上减少了jar hell或者dependency hell</p></li>
<li><p>自动进行Spring框架的配置，节省程序员大量的时间和精力，能够让程序员专注在业务逻辑代码的编写上</p></li>
<li><p>不需要任何第三方系统, Spring Boot自带了可以用于生产环境的程序状态信息和健康状态。同时可以让应用程序非常方便的读取外部的配置信息</p></li>
<li><p>完全不需要任何代码的自动生成。更不需要用xml来进行框架的配置</p></li></ul>
<h2><strong>为什么Spring Boot是颠覆性的？</strong></h2>
<p>为什么说Spring Boot是颠覆性的呢？因为它彻底改变了Java应用开发的模式。以往我们做Spring应用开发，要知道配置哪些类来让Hibernate和Spring一起工作，要知道如何配置view resolver来控制哪个模版进行视图层的展示。经常写了一大堆代码之后发现只是在处理Spring框架本身的配置，根本一行业务逻辑都没有写。开发完成之后，我们还要考虑部署的问题，且不说部署到非常笨重的应用服务器，比如WebSphere, Weblogic或者JBoss，即使部署到Tomcat或者Jetty这种轻量级容器上面，我们要知道如何配置容器，如何修改配置文件等等。而且在多应用部署到同一个Tomcat的时候，经常会出现冲突。就算我们花了很大力气解决了这些问题，程序部署成功之后，我们很难去了解这个程序的运行状态。有可能我们要配置很多第三方工具来去知道这个应用程序运行状态如何，有哪些参数，环境变量是什么。尽管Spring帮我们解决了依赖注入的问题，简化了一些MVC的流程，但是Spring框架本身集成了越来越多东西，导致其越来越难配置，维护成本成直线上升。很多时候Java程序员们看到Python, Ruby或者JavaScript程序员敲几个命令安装一些库，然后简单的敲几行代码，引入一些框架比如flask，然后直接一个简单的API就可以跑起来了。这时候Java程序员可能还在研究该使用Maven里面的哪个库，如何在代码里面进行配置呢。大家心里的表情肯定是这样：</p>
<p><img referrerpolicy="no-referrer"src="http://img2.tuicool.com/rQJn2am.png!web"></p>
<p>(求此时Java程序员心理阴影面积)</p>
<p>Java程序员扬眉吐气的时候到了！</p>
<p><img referrerpolicy="no-referrer"src="http://img2.tuicool.com/6JZvu2A.png!web"></p>
<h2><strong>传统Spring开发对决Spring Boot应用开发</strong></h2>
<p>接下来我会通过具体例子对比传统的Spring应用开发和Spring Boot应用开发。假如我们开发一个Hello World的REST API，传统的Spring开发应该这么做.</p>
<p>1. 如果使用Maven进行包管理，编写pom.xml 如下</p>
<p><img referrerpolicy="no-referrer"src="http://img1.tuicool.com/meeiQfZ.png!web"><img referrerpolicy="no-referrer"src="http://img0.tuicool.com/RnYBBzi.png!web"></p>
<p>如上可以看到为了编写简单的hello world REST API我们引入了Spring Core, Spring Web, Spring Web MVC, Java Servlet and Jackson这么多包依赖。可以想象复杂一点的程序这个pom会变成什么样。。。</p>
<p>2. 编写HelloWorldInitializer class如下</p>
<p><img referrerpolicy="no-referrer"src="http://img2.tuicool.com/UVNjYfq.png!web"></p>
<p>这个已经是非常简单的Java Config了，在Servlet 3.0之前用XML配置Spring的小伙伴们现在估计已经崩溃。</p>
<p>3. 编写HelloWorldConfiguration class</p>
<p><img referrerpolicy="no-referrer"src="http://img2.tuicool.com/uaU7Bvi.png!web"></p>
<p>注意到我们这个类里面一行业务逻辑都没有哦。。。</p>
<p>4. 真正开始编写HelloWorldRestController</p>
<p><img referrerpolicy="no-referrer"src="http://img0.tuicool.com/Eje6feu.png!web"></p>
<p>5. 下载Tomcat</p>
<p>6. 打包部署到Tomcat上</p>
<p>7.访问localhost:8080/HelloWorld, 你终于看到了Hello World…</p>
<p>写到这里我已经累觉不爱了。。。</p>
<p><strong>接下来Java老司机会带领你们感受一下Spring Boot的魅力：</strong></p>
<p><img referrerpolicy="no-referrer"src="http://img0.tuicool.com/eQBrMvq.png!web"></p>
<p>1. 编写pom.xml</p>
<p><img referrerpolicy="no-referrer"src="http://img1.tuicool.com/V3yINb2.png!web"><img referrerpolicy="no-referrer"src="http://img0.tuicool.com/bqmMRjn.png!web"></p>
<p>注意到我们只引入了一个包依赖，并且版本什么的就随他去吧</p>
<p>2. 编写main 函数</p>
<p><img referrerpolicy="no-referrer"src="http://img1.tuicool.com/iIn6ria.png!web"></p>
<p>我们在这里标记HelloWorldDemoApplication class为SpringBootApplication, Spring Boot 在后台会根据这个标记进行很多自动配置，比如配置MVC，配置包扫描，注入必要的类，注入自动配置的类等等。</p>
<p>这里的main函数是一个java标准的main函数，这个相当于应用程序入口，servlet container会在启动的时候找到这个入口，启动Spring container，完成初始化。</p>
<p>3. 编写HelloWorldRestController</p>
<p><img referrerpolicy="no-referrer"src="http://img1.tuicool.com/y2aI7rv.png!web"></p>
<p>4. 直接启动应用程序，不需要部署</p>
<p><img referrerpolicy="no-referrer"src="http://img2.tuicool.com/eu6vYze.png!web"></p>
<p>5. 访问就可以直接看到Hello World了</p>
<p><img referrerpolicy="no-referrer"src="http://img2.tuicool.com/Ary2qmA.png!web"></p>
<p>之前HelloWorld程序对于新手来说至少要花个10-20分钟之类的，有了SpringBoot, 最多3分钟之内搞定HelloWorld不是梦。</p>
<p><strong>总结</strong></p>
<p>这里我只是简单的对SpringBoot进行了讲解，SpringBoot有非常多值得深入讨论的东西，它不仅让我们做Java开发变的简单有效，更重要的是SpringBoot彻底颠覆了我们对Java开发的认识，让我们第一次有了”原来Java开发可以这么做” 的感觉。有了SpringBoot之后，Java程序员可以更专注于业务逻辑，进行更敏捷的开发。</p>
<p><strong>学习Java的同学注意了！！！</strong><br>学习过程中遇到什么问题或者想获取学习资源的话，欢迎加入Java学习交流群，群号码：<strong>184625948</strong>【长按复制】 我们一起学Java！</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m96pog38.html">ionic的常用命令总结以及正式发布的准备</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pmyj79.html">Java中简单的操作（if语句、常用操作符、switch语句、变量赋值等）</a>
		</li>
						<li><a href="https://www.batexi.com/a/390lv1j9.html">C 语言学习的第 04 课：编译器常见错误和警告&lpar;1&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7643k8.html">mysql 为字段增加主键</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q741jxq.html">【现代程序设计】homework-03</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8moe429.html">mysql时该如何估算内存的消耗，公式如何计算？</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn11jgj8.html">HNOI2006-鬼谷子的钱袋</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdy4dr8.html">Secant Method &lpar;Website&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjwykg8.html">字符串&lpar;String&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpxegxq.html">如何用九条命令在一分钟内检查Linux服务器性能？</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pem7y8.html">Linux学习历程&mdash;&mdash;Centos 7  ls命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzwjwl8.html">&lbrack;Swift&rsqb;LeetCode789&period; 逃脱阻碍者 &vert; Escape The Ghosts</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zom0pdq.html">Mysql索引机制&lpar;B&plus;Tree&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwwxnj9.html">【分布式事务】基于RocketMQ搭建生产级消息集群？</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5wlg4q.html">word中从正文开始编码的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jr3znq.html">kali域名解析错误解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj3e0j9.html">MaxScript与外部程序通讯</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkgwxd8.html">Sprint计划会议内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k3rylq.html">为镜像添加SSH服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvlk5dq.html">在 ASP&period;NET Web API 中，使用 命名空间（namespace） 来作为路由的参数</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/jqdw5lj9.html">玩转Windows服务系列&mdash;&mdash;创建Windows服务</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8o1vpxq.html">Functional Programming without Lambda - Part 2 Lifting&comma; Functor&comma; Monad</a>
			</li>
						<li><a href="https://www.batexi.com/a/m9607e39.html">&lbrack;ASP&period;NET MVC 小牛之路&rsqb;17 - 捆绑&lpar;Bundle&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zyj7d9.html">JavaScript学习笔记之数值</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q250zvq.html">fc-san</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96051y9.html">每天一个linux命令&lpar;25&rpar;：linux文件属性详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pw3py8.html">Android RatingBar 自定义样式</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1r4w08.html">Mysql5&period;7&period;13主从同步（复制）配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pwg6d8.html">datagrid可编辑表格</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqv2jj19.html">Ado net Source 用法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
